--[[
	AUTOCL part Molda [EU - Rashgarroth]
	Addon developp pour Wow Web Stats part Lossendil aka Saulne [EU - Rashgarroth]

	Cet addon active /combatlog et specifie les "range log" durant les instances choisies

	Version 1.1
	7 sept 2006
]]


--------------------------------------------------------------------------------------------------
-- Variables a sauver
--------------------------------------------------------------------------------------------------
state_log 		= 0;			-- logging ?
state_cl 		= 0;			-- autocl is ON / OFF ?
state_info		= {1,1}	 ;		-- affichage viewport / chatlog
state_rl		= 0;			-- rang log ?
range_log_select 	= { 30, 50, 50, 50, 50, 60};
LIST_INST		= nil;


--------------------------------------------------------------------------------------------------
-- Variables locales
--------------------------------------------------------------------------------------------------
local current_zone 	= 0;	
local all_loaded = 0;		 

--------------------------------------------------------------------------------------------------
-- Functions
--------------------------------------------------------------------------------------------------
function AutoCL_show(cmd)

	if (LoggingCombat() == 1) then
		AC_G_Status_Value:SetText("/combatlog ON !");
		AC_G_Status_Value:SetTextColor(0, 1, 0);
	else
		AC_G_Status_Value:SetText("/combatlog OFF");
		AC_G_Status_Value:SetTextColor(1, 0, 0);
	end	

	if (Autocl_General_Frame:IsVisible() ) then
		HideUIPanel(Autocl_General_Frame);
	else
		ShowUIPanel(Autocl_General_Frame);
		ShowUIPanel(Autocl_Menu1_Frame);
		HideUIPanel(Autocl_Menu2_Frame);
		HideUIPanel(Autocl_Menu3_Frame);
		Autocl_tab_1:SetChecked(1);
		Autocl_tab_2:SetChecked(0);
		Autocl_tab_3:SetChecked(0);
	end
	AC_C_Info_Cur_value:SetText(GetRealZoneText());
end


function Autocl_OnLoad()
	
	
	UIPanelWindows["LootFrame"] = nil;

	if( DEFAULT_CHAT_FRAME ) then
		DEFAULT_CHAT_FRAME:AddMessage("AutoCL "..AUTOCL_VERSION.." loaded. Type /autocl to open the menu");

	end

	Autocl_General_Version:SetText("Autocl "..AUTOCL_VERSION);

	
	
	
	SlashCmdList["AUTOCL"] = AutoCL_show;
	SLASH_AUTOCL1 = "/autocl";

	UIErrorsFrame:AddMessage("AutoCL "..AUTOCL_VERSION.." loaded !", 0.5, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);

	this:RegisterEvent("VARIABLES_LOADED");
	
end

function AutoCL_loadvar()

	Autocl_Menu1_LoadVar();
	Autocl_Menu2_LoadVar();
	Autocl_Menu3_LoadVar();
	this:RegisterEvent("ZONE_CHANGED");
	this:RegisterEvent("MINIMAP_ZONE_CHANGED");
	this:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	
	all_loaded = 1;
	
	
	AutoCL_check();
	
end



function AutoCL_OnEvent()
	if (event == "VARIABLES_LOADED") then
		AutoCL_loadvar();
	end
	if (event == "ZONE_CHANGED") then
		AutoCL_check();
	end
	if (event == "MINIMAP_ZONE_CHANGED") then
		
		AutoCL_check();
	end
	if (event == "ZONE_CHANGED_NEW_AREA") then
		
		AutoCL_check();
	end
end

function AutoCL_check()
	
	-- Color code r g b
	local tobelog = 0;
	tobelog = 0;

	

	if( all_loaded ==1) then

	if( state_cl == 1) then -- si autocl ON
		
		if(GetRealZoneText() == current_zone) then
			--nada
		else
			current_zone = GetRealZoneText();
		end


		for i = 1, getn(LIST_INST), 1 do
			
			if current_zone == LIST_INST[i] then
				tobelog=1;
				
			end
		end

		
		if( tobelog == 1) then -- Si doit activer /combatlog
			
			if( state_log ==0 ) then
				state_log = LoggingCombat(1) ;
				
				
				if( state_info[1] == 1) then
					DEFAULT_CHAT_FRAME:AddMessage("[AutoCL] CombatLog ON",0,1,0);	
				end
				if( state_info[2] == 1) then
					UIErrorsFrame:AddMessage("CombatLog ON", 0.2, 1, 0.2, 1.0, UIERRORS_HOLD_TIME);	
				end

				AC_G_Status_Value:SetText("/combatlog ON !");
				AC_G_Status_Value:SetTextColor(0, 1, 0);
				set_setcvar_rl();

			end
		else -- Ne dois pas etre activ
			
			if( state_log == 1) then  -- si actuellement activ, on desactive
				state_log = LoggingCombat(0) ;
				state_log = 0;


				if( state_info[1] == 1) then
					DEFAULT_CHAT_FRAME:AddMessage("[AutoCL] CombatLog OFF",1,0,0);	
				end
				if( state_info[2] == 1) then
					UIErrorsFrame:AddMessage("CombatLog OFF ", 1.0, 0, 0, 1.0, UIERRORS_HOLD_TIME);
				end
				AC_G_Status_Value:SetText("/combatlog OFF");
				AC_G_Status_Value:SetTextColor(1, 0, 0);
				set_setcvar_rl_default();
			end
			
		end

	end

	end

	AC_C_Info_Cur_value:SetText(GetRealZoneText());
end

function AutoCL_set()
	if( state_cl == 1) then
		DEFAULT_CHAT_FRAME:AddMessage("[AutoCL] is now turned OFF ");
		state_cl = 0;

		if( state_log == 1) then
			state_log = LoggingCombat(0) ;
			state_log = 0;

			if( state_info[1] == 1) then
				DEFAULT_CHAT_FRAME:AddMessage("[AutoCL] CombatLog OFF", 1, 0, 0);	
			end
			if( state_info[2] == 1) then
				UIErrorsFrame:AddMessage("CombatLog OFF", 1.0, 0, 0, 1.0, UIERRORS_HOLD_TIME);
			end

			AC_G_Status_Value:SetText("/combatlog OFF");
			AC_G_Status_Value:SetTextColor(1, 0, 0);
			set_setcvar_rl_default();
		end
	else
		state_cl = 1;
		
		DEFAULT_CHAT_FRAME:AddMessage("[AutoCL] is now turned ON");	
		AutoCL_check();	
	end
	
end

function set_setcvar_rl()
	if (state_rl == 1) then
		SetCVar("CombatLogRangeParty",range_log_select[1] ) 
		SetCVar("CombatLogRangeCreature",range_log_select[2] ) 
		SetCVar("CombatLogRangePartyPet",range_log_select[3] )
		SetCVar("CombatLogRangeFriendlyPlayers",range_log_select[4])
		SetCVar("CombatLogRangeFriendlyPlayersPets", range_log_select[5] )
		SetCVar("CombatDeathLogRange",range_log_select[6] )
	end
end

function set_setcvar_rl_default()
		SetCVar("CombatLogRangeCreature","30" ) 
		SetCVar("CombatLogRangePartyPet","50" )
		SetCVar("CombatLogRangeFriendlyPlayers","50")
		SetCVar("CombatLogRangeFriendlyPlayersPets", "50" )
		SetCVar("CombatDeathLogRange","60" )
		SetCVar("CombatLogRangeParty","50" ) 
end
