-- Utilisation de MyModScrollBar sur WOWWIKI
-- www.wowwiki.com/HOWTO:_Make_a_Scrollable_List_Using_FauxScrollFrameTemplate

function Autocl_Menu2_LoadVar()
	if( state_info[1] == 1 ) then
		AC_C_Av_But_1:SetChecked(1);
	end

	if( state_info[2] == 1 ) then
		AC_C_Av_But_2:SetChecked(1);
	end
	
	if( LIST_INST == nil) then
		LIST_INST = LIST_INST_DEFAULT;
	end

	AC_I_Del_But:Disable();

end


function Autocl_Menu2_Del_But_Clic()

	table.remove( LIST_INST,  MyModScrollBar.selected);
	table.sort( LIST_INST);
	MyModScrollBar.selected = nil;
	MyModScrollBar_Update();
	AC_I_Del_But:Disable();
	AutoCL_check();
end

function Autocl_Menu2_Add_But_Clic()

	local already_in = 0;
	current_zone = GetRealZoneText();

	for i=1,getn(LIST_INST),1 do
		if current_zone == LIST_INST[i] then
			already_in = 1;
		end
	end
	if already_in == 0 then
	
		table.insert(LIST_INST, current_zone);
		table.sort( LIST_INST);
		
		MyModScrollBar_Update();
	else
		DEFAULT_CHAT_FRAME:AddMessage( AUTOCL_CONFIG.Configuration.Zone_exist);
	end

	AutoCL_check();
	
end

function Autocl_Scroll_Clic(button)

   if( button == "LeftButton" ) then
      MyModScrollBar.selected = this:GetID() + FauxScrollFrame_GetOffset(MyModScrollBar);
      
	AC_I_Del_But:Enable();
      MyModScrollBar_Update()
   end

end


function Autocl_Menu2_OnLoad()

	AC_C_Titre:SetText(AUTOCL_CONFIG.Configuration.Titre);
	AC_C_Titre_1:SetText(AUTOCL_CONFIG.Configuration.Titre_1);
	AC_C_Av_1:SetText(AUTOCL_CONFIG.Configuration.Av_1);
	AC_C_Av_2:SetText(AUTOCL_CONFIG.Configuration.Av_2);
	AC_C_Titre_2:SetText(AUTOCL_CONFIG.Configuration.Titre_2);
	AC_I_Del_But:SetText(AUTOCL_CONFIG.Configuration.But_Del);
	AC_I_Add_But:SetText(AUTOCL_CONFIG.Configuration.But_Add);

  	MyModScrollBar:Show()

	AC_C_Info_Cur_value:SetText(GetRealZoneText());

end

function MyModScrollBar_Update()

  local line; -- 1 through 5 of our window to scroll
  local lineplusoffset; -- an index into our data calculated from the scroll offset

  
	table.sort( LIST_INST);
  FauxScrollFrame_Update(MyModScrollBar,getn(LIST_INST),10,16);

  for line=1,10,1 do

    lineplusoffset = line + FauxScrollFrame_GetOffset(MyModScrollBar);

    if lineplusoffset <= getn(LIST_INST) then
	if MyModScrollBar.selected~= nil then
	
	end;

	if lineplusoffset ==MyModScrollBar.selected then
		getglobal("MyModEntry"..line.."_Text"):SetTextColor(1.0,0,0);
	else
		getglobal("MyModEntry"..line.."_Text"):SetTextColor(1.0,1.0,1.0);
	end
      	getglobal("MyModEntry"..line.."_Text"):SetText(LIST_INST[lineplusoffset]);
	
      	getglobal("MyModEntry"..line):Show();
    else
	
      	getglobal("MyModEntry"..line):Hide();
    end
  end
end

function AutoCL_setCB_M(id)
	if( state_info[id] == 0) then
		state_info[id] = 1;
		
	else
		state_info[id] = 0;
		
	end

end