-------------------
-- Variables
-------------------

-- variable defaut
local RANGE_LOG= { {30, 50, 50, 50, 50, 60},{60, 80, 80, 80, 80, 60},{100,100,100,100,100,100}};

local range_log_select_TEMP = { 0, 0, 0, 0, 0, 0};


function Autocl_Menu3_LoadVar()
	if( state_rl == 1) then
		AC_A_Av_CB:SetChecked(1);
		AC_A_Av_But_Default:Enable();
		AC_A_Av_But_High:Enable();
		AC_A_Av_But_VHigh:Enable();
	end

	for i =1, 6, 1 do
		getglobal("AC_A_Ex_"..i.."_sli"):SetValue(range_log_select[i]);
	end
	set_info_rl();
	
end



function Autocl_Menu3_Save()

	for i =1, 6, 1 do
		range_log_select[i] = range_log_select_TEMP[i];
	end
	AC_A_Ex_Save_But:Disable();

	is_found = 0;
	for j=1,3,1 do
		is_equal = 1;
		for i=1,6,1 do
			if RANGE_LOG[j][i] ~= range_log_select[i] then
				is_equal = 0;
			end
		end
		if is_equal == 1 then
			is_found = j;
		end
	end

	if is_found > 0 then
		AC_A_Av_Info_Selected:SetText(AUTOCL_CONFIG.Avance.Range_choice[is_found]);
	else
		AC_A_Av_Info_Selected:SetText(AUTOCL_CONFIG.Avance.Range_choice[4]);
	end

	DEFAULT_CHAT_FRAME:AddMessage(AUTOCL_CONFIG.Avance.Info_save);
	set_info_rl();
end


function Autocl_Menu3_Ex_OnValueChanged(id)
	
	if state_rl == 1 then
		is_changed = 0;

		range_log_select_TEMP[id] = getglobal("AC_A_Ex_"..id.."_sli"):GetValue();

		
		for i =1, 6, 1 do
			
			if range_log_select[i] ~= range_log_select_TEMP[i] then
				is_changed = 1;
			end
		end
		
	
		if is_changed == 1 then
			AC_A_Ex_Save_But:Enable();
		else
			AC_A_Ex_Save_But:Disable();
		end	
	else
		getglobal("AC_A_Ex_"..id.."_sli"):SetValue(range_log_select[id]);
	end
	
end

function Autocl_Menu3_Av_Clic()
	if state_rl == 0 then -- pas cliqu
		state_rl = 1;
		AC_A_Av_But_Default:Enable();
		AC_A_Av_But_High:Enable();
		AC_A_Av_But_VHigh:Enable();
		set_info_rl();

	else
		state_rl = 0;
		AC_A_Av_But_Default:Disable();
		AC_A_Av_But_High:Disable();
		AC_A_Av_But_VHigh:Disable();
		AC_A_Ex_Save_But:Disable();
		for i=1,6,1 do
			Autocl_Menu3_Ex_OnValueChanged(i);
		end
		
	end	
end



function Autocl_Menu3_Av_But_Clic(id)

	for i =1, 6, 1 do
		getglobal("AC_A_Ex_"..i.."_sli"):SetValue(RANGE_LOG[id][i]);
	end
	
end

function Autocl_Menu3_OnLoad()

	AC_A_Titre:SetText(AUTOCL_CONFIG.Avance.Titre);
	AC_A_Av_Act:SetText(AUTOCL_CONFIG.Avance.Av_Act);
	
	AC_A_Av_But_High:SetText(AUTOCL_CONFIG.Avance.Range_choice[2])
	AC_A_Av_But_Default:SetText(AUTOCL_CONFIG.Avance.Range_choice[1])
	AC_A_Av_But_VHigh:SetText(AUTOCL_CONFIG.Avance.Range_choice[3])

	AC_A_Ex_Info:SetText(AUTOCL_CONFIG.Avance.Ex_Info);
	AC_A_Ex_1:SetText(AUTOCL_CONFIG.Avance.Ex_Creature);
	AC_A_Ex_2:SetText(AUTOCL_CONFIG.Avance.Ex_Party);
	AC_A_Ex_3:SetText(AUTOCL_CONFIG.Avance.Ex_PartyPet);
	AC_A_Ex_4:SetText(AUTOCL_CONFIG.Avance.Ex_FriendlyPlayers);
	AC_A_Ex_5:SetText(AUTOCL_CONFIG.Avance.Ex_FriendlyPlayersPets);
	AC_A_Ex_6:SetText(AUTOCL_CONFIG.Avance.AC_A_Ex_Death);

	if state_rl == 0 then
		AC_A_Av_CB:SetChecked(0);
		AC_A_Av_But_Default:Disable();
		AC_A_Av_But_High:Disable();
		AC_A_Av_But_VHigh:Disable();
	else
		AC_A_Av_CB:SetChecked(1);
		AC_A_Av_But_Default:Enable();
		AC_A_Av_But_High:Enable();
		AC_A_Av_But_VHigh:Enable();
	end

	for i =1, 6, 1 do
		getglobal("AC_A_Ex_"..i.."_sli"):SetValue(range_log_select[i]);
		range_log_select_TEMP[i] = range_log_select[i];
	end

	

	AC_A_Ex_Save_But:Disable();
	set_info_rl();

end

function set_info_rl()
	local is_found = 0;
	for j=1,3,1 do
		is_equal = 1;
		for i=1,6,1 do
			if RANGE_LOG[j][i] ~= range_log_select[i] then
				is_equal = 0;
			end
		end
		if is_equal == 1 then
			is_found = j;
		end
	end

	if is_found > 0 then
		AC_A_Av_Info_Selected:SetText(AUTOCL_CONFIG.Avance.Range_choice[is_found]);
	else
		AC_A_Av_Info_Selected:SetText(AUTOCL_CONFIG.Avance.Range_choice[4]);
	end
end

