-- Fichier de localization pour AUTOCL V1.1


--######################################
AUTOCL_VERSION = "v1.1"


LIST_INST_DEFAULT = {}	;

AUTOCL_CONFIG =
{
		["Menu1"] = "Main",
		["Menu2"] = "Configuration",
		["Menu3"] = "Advanced",
		["General"] =
		{
			["Titre"] = "AutoCL "..AUTOCL_VERSION.." (for Wow v2.0)",
			["Detail"] = "Thank you for using Autocl !\n\nThis addon starts and stop the \ncombat log (/combatlog) automaticaly in\na HL PVE area.\n\nConfiguration menu :\n-add your own instance\nAdvanced menu : \n-change the logging range.\n\nHave fun !\n",
			["Active"] = "Enable AutoCL",
			["By"] = "By Molda for Wow Web Stat (by Lossendil)\nhttp://www.lossendil.fr",
		},
		["Configuration"] =
		{
			["Titre"] = "Configuration panel",
			["Titre_1"] = "Notify on de/activation :",
			["Av_1"] = "On chatlog",
			["Av_2"] = "On viewport",
			["Titre_2"] = "Start /combatlog in :",
			["But_Del"] = "Delete",
			["But_Add"] = "Add current",
			["Zone_exist"] = "[AUTOCL] This zone already exists",
		},
		["Avance"] =
		{
			["Titre"] = "Advanced panel",
			["Info_save"] = "[AutoCL] Logging range parameters saved",
			["Av_Act"] = "Enable logging range ",
			["Av_Info"] = "Current config :",
			["Ex_Info"] = "Manual config :",
			["Ex_Party"] = "Group", 
			["Ex_Creature"]= "Creature", 
			["Ex_PartyPet"]= "PartyPets", 
			["Ex_FriendlyPlayers"] = "Friendlyplayers", 
			["Ex_FriendlyPlayersPets"]= "FriendlyplayersPets", 
			["AC_A_Ex_Death"]="Death" ,
			["Range_choice"] = {"Default", "High", "Very High", "Manual"},
		}
};


if ( GetLocale() == "frFR" ) then
	
	
AUTOCL_CONFIG = 
{
		["Menu1"] = "G\195\169n\195\169ral",
		["Menu2"] = "Configuration",
		["Menu3"] = "Avanc\195\169",
		["General"] =
		{
			["Titre"] = "AutoCL "..AUTOCL_VERSION.." (compatible Wow v1.12)",
			["Detail"] = "Merci d\'utiliser AutoCL !\nCet addon va g\195\169rer automatiquement\nl\'activation de /combatlog durant vos\ninstances.\n\nMenu Configuration :\n     - s\195\169l\195\169ctionner vos instances\nMenu Avanc\195\169 : \n     - modifer les \"ranges log\"\n\nBon jeu et bonne stats :)\n",
			["Active"] = "Activer AutoCL",
			["By"] = "Par MOLDA pour Wow Web Stat (par LOSSENDIL)\nhttp://www.lossendil.fr",
		
		},
		["Configuration"] =
		{
			["Titre"] = "Ecran de configuration",
			["Titre_1"] = "Avertir lors des activations/desactivations :",
			["Av_1"] = "Sur le chatlog",
			["Av_2"] = "Sur le viewport",
			["Titre_2"] = "Activer /combatlog dans les zones :",
			["But_Del"] = "Supprimer",
			["But_Add"] = "Ajout zone",
			["Zone_exist"] = "[AUTOCL] Cette zone existe d\195\169ja.",
		},
		["Avance"] =
		{
			["Titre"] = "Options avanc\195\169es",
			["Info_save"] = "[AutoCL] Param\195\170tres \"range log\" sauv\195\169s.",
			["Av_Act"] = "Sp\195\169cifier le \"range log\"",
			["Av_Info"] = "Configuration actuelle :",
			["Ex_Info"] = "Param\195\170trage manuel :",
			["Ex_Party"] = "Groupe", 
			["Ex_Creature"]= "Cr\195\169atures", 
			["Ex_PartyPet"]= "Minions de groupe", 
			["Ex_FriendlyPlayers"] = "Joueurs alli\195\169s", 
			["Ex_FriendlyPlayersPets"]= "Minions joueurs alli\195\169s", 
			["AC_A_Ex_Death"]="Mort",
			["Range_choice"] = {"D\195\169faut", "Haut", "Tr\195\169s haut", "Manuel"},
		}
		
};
end